Перейти к основному содержимому

Angular Scheduler Overview

Angular Scheduler is the official Angular wrapper for DHTMLX Scheduler. It exposes the Scheduler as an Angular component (<dhx-scheduler>) with typed inputs/outputs and keeps access to the underlying Scheduler instance.

If you need installation and project setup first, start with Quick Start with Angular Scheduler.

Core Capabilities​

The wrapper is built for both simple and advanced Angular integrations:

  • Declarative setup with events, date, view, config, templates, plugins, theme, and locale.
  • Controlled event synchronization through events.
  • Change handling through data.save and data.batchSave.
  • Callback wiring through on<EventName> inputs.
  • Lifecycle signal via (ready) with access to the initialized Scheduler instance.
  • Angular-based customization hooks: customLightbox, eventBoxRenderer, modals, and templateComponent(...).
  • Extra view registration through views for Timeline, Units, and Grid configurations.

Basic Wrapper Usage​

Use inputs for calendar data, configuration, and event handling.

import { Component } from "@angular/core";
import {
DhxSchedulerComponent,
type AngularSchedulerDataConfig,
type Event,
type SchedulerConfig,
} from "@dhx/angular-scheduler";

@Component({
selector: "app-scheduler",
standalone: true,
imports: [DhxSchedulerComponent],
template: `
<dhx-scheduler
[events]="events"
[date]="date"
[config]="config"
[data]="data"
view="week">
</dhx-scheduler>
`,
})
export class SchedulerComponent {
date = new Date("2026-05-18T00:00:00");
events: Event[] = [
{
id: 1,
text: "Planning",
start_date: new Date("2026-05-18T09:00:00"),
end_date: new Date("2026-05-18T10:30:00"),
},
];

config: SchedulerConfig = {
first_hour: 8,
last_hour: 20,
time_step: 30,
};

data: AngularSchedulerDataConfig = {
save: (entity, action, item, id) => {
console.log("[scheduler save]", entity, action, item, id);
},
};
}

For the full input list, use Configuration Reference.

Choose A Data Ownership Model​

The wrapper supports two main data ownership models.

  • Angular state or store as source of truth: pass events, handle edits through data.save or data.batchSave, and update Angular state.
  • Scheduler as source of truth: omit events, load data through data.load, and let Scheduler and your backend own the live data lifecycle.

When Angular owns the data, prefer typed SerializedEvent[] state so the rest of your application can react to Scheduler changes.

Use Data Binding and State Management Basics for full data ownership guidance.

Handle Events​

Use on<EventName> inputs for Scheduler callbacks and (ready) for one-time setup after initialization.

<dhx-scheduler
[events]="events"
[onBeforeLightbox]="beforeLightbox"
(ready)="onReady($event)">
</dhx-scheduler>
import type { SchedulerStatic } from "@dhtmlx/trial-angular-scheduler";

beforeLightbox = (eventId: string | number) => {
console.log("before lightbox", eventId);
return true;
};

onReady(event: { instance: SchedulerStatic }): void {
console.log("ready", event.instance);
}

Use event inputs for interaction behavior. Use (ready) for logic that requires an initialized instance.

ViewChild Access And Imperative Boundaries​

When inputs are not enough, access the wrapper instance with @ViewChild and then use .instance.

import { Component, ViewChild } from "@angular/core";
import { DhxSchedulerComponent } from "@dhx/angular-scheduler";

export class DirectApiDemoComponent {
@ViewChild(DhxSchedulerComponent) schedulerComponent?: DhxSchedulerComponent;

showAlert(): void {
this.schedulerComponent?.instance?.alert({
title:"Alert",
type:"alert-error",
text:"You can't do this"
});
}
}

If you mutate event data through instance, keep Angular state in sync. Otherwise the next controlled events update can overwrite those changes.

Advanced Extension Points​

Custom lightbox component​

Use customLightbox to replace the built-in event lightbox with an Angular component.

<dhx-scheduler [events]="events" [customLightbox]="CustomLightboxComponent"></dhx-scheduler>

Your custom component should accept data, onSave, onCancel, and onDelete inputs.

Custom event box rendering​

Render Scheduler event boxes yourself with eventBoxRenderer:

eventBoxRenderer = ({ event }) => `#${event.id}: ${event.text}`;

Custom delete and recurrence confirmation flow​

Override confirmations with modals:

modals = {
onBeforeEventDelete: ({ event, callback }) => {
if (window.confirm(`Delete ${event.text}?`)) callback();
},
};

Filtering​

Use the filter input to specify which events should be displayed:

...
query = "";
get eventFilter() {
const value = this.query.trim().toLowerCase();
return (event: Event) => !value || String(event.text || "").toLowerCase().includes(value);
}
  <dhx-scheduler
[events]="events"
[filter]="eventFilter"
[views]="views"
></dhx-scheduler>

Extra Scheduler views​

Use views to configure Timeline, Units, or Grid views and enable required plugins through plugins if needed.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

Vue Scheduler Overview

Vue Scheduler is the official Vue wrapper for DHTMLX Scheduler. It combines Vue-friendly composition patterns with full access to the underlying Scheduler engine.

If you need setup instructions first, start with Quick Start with Vue Scheduler.

How the Wrapper Works​

Vue Scheduler is a wrapper around the DHTMLX Scheduler engine. The wrapper gives you a Vue component API, but the underlying engine is still the source of scheduler behavior and low-level methods.

The wrapper layer handles three things:

  • initializes and destroys the Scheduler instance with Vue lifecycle
  • syncs selected Vue props into the current Scheduler instance
  • exposes wrapper-specific extension points (on<EventName> listeners, @ready, customLightbox, eventBoxRenderer, composables)

That means you can stay declarative for most integration work and still drop down to instance when needed.

Core Capabilities​

The wrapper covers both basic and advanced integration scenarios:

  • Declarative setup with props (events, date, view, config, templates, plugins, theme, locale)
  • Controlled event synchronization through events
  • Scheduler-owned loading through data.load when events is omitted
  • Change handling through data.save and data.batchSave
  • Callback wiring through Vue on<EventName> listeners and useSchedulerEvent
  • One-time lifecycle hook through @ready
  • Vue-based customization hooks (customLightbox, eventBoxRenderer, modals)
  • Typed helpers and composables for reusable patterns

Scenario: Basic Wrapper Setup​

Use props for calendar data, configuration, and template customization.

<script setup lang="ts">
import {
VueScheduler,
defineSchedulerConfig,
defineSchedulerTemplates,
type Event
} from "@dhtmlx/trial-vue-scheduler";
import "@dhtmlx/trial-vue-scheduler/dist/vue-scheduler.css";

const events: Event[] = [
{
id: 1,
text: "Planning",
start_date: new Date("2026-05-18T09:00:00"),
end_date: new Date("2026-05-18T10:30:00"),
classname: "event-planning"
}
];

const config = defineSchedulerConfig({
first_hour: 8,
last_hour: 20,
time_step: 30
});

const templates = defineSchedulerTemplates({
event_class: (_start, _end, event) => event.classname || ""
});
</script>

<template>
<div :style="{ height: 600px; }">
<VueScheduler
:events="events"
:date="new Date('2026-05-18T00:00:00')"
view="week"
:config="config"
:templates="templates"
/>
</div>
</template>

For the full prop list, use Configuration Reference.

Choose A Data Ownership Model​

The wrapper supports two main data ownership models.

  • Vue state/store as source of truth: pass events, handle edits through data.save or data.batchSave, and update Vue state.
  • Scheduler as source of truth: omit events, load data through data.load, and let Scheduler and your backend own the data lifecycle.

When Vue owns the data, prefer typed SerializedEvent[] state so other Vue components can react to Scheduler changes.

Use Data Binding and State Management Basics for the tradeoffs and callback contracts.

Handle Events And Startup Logic​

Use Vue on<Eventname> listeners for Scheduler callbacks and @ready for one-time setup after initialization.

<script setup lang="ts">
import type { SchedulerStatic } from "@dhtmlx/trial-vue-scheduler";

function beforeLightbox(eventId: string | number) {
console.log("before lightbox", eventId);
return true;
}

function onReady(instance: SchedulerStatic) {
console.log("ready", instance);
}
</script>

<template>
<VueScheduler :onBeforeLightbox="beforeLightbox" @ready="onReady" />
</template>

Use listeners for interaction behavior. Use @ready for initialization logic that needs a live instance.

Cross The Imperative Boundary​

Use a component ref when you need methods that are not practical to model through props.

<script setup lang="ts">
import { onMounted, ref } from "vue";
import { VueScheduler, type VueSchedulerRef } from "@dhtmlx/trial-vue-scheduler";

const schedulerRef = ref<VueSchedulerRef | null>(null);

onMounted(() => {
const scheduler = schedulerRef.value?.instance;
schedulerRef.message({
text:"Scheduler is mounted"
});
});
</script>

<template>
<VueScheduler ref="schedulerRef" />
</template>

If you mutate event data through instance, keep external state in sync. Otherwise the next controlled listener can overwrite those changes.

Advanced Extension Points​

Custom lightbox component​

Replace the built-in event form with a Vue component:

<VueScheduler :events="events" :customLightbox="CustomLightbox" :data="data" />

Custom event box rendering​

Render Scheduler event boxes yourself with eventBoxRenderer:

const eventBoxRenderer = ({ event }) => `#${event.id}: ${event.text}`;

Custom delete and recurrence confirmation flow​

Override confirmations with modals:

const modals = {
onBeforeEventDelete: ({ event, callback }) => {
if (window.confirm(`Delete ${event.text}?`)) callback();
}
};

Extra Scheduler views​

Use views to configure Timeline, Units, or Grid views and enable required plugins through plugins if needed.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

React Scheduler

примечание

React Scheduler доступен по лицензиям [Commercial, Enterprise и Ultimate]. Если вы используете Individuals или GPL-версии Scheduler, используйте dhtmlxScheduler with React.

Обзор​

DHTMLX React Scheduler — официальный обёртка для DHTMLX Scheduler на React. Он предоставляет декларативный API для рендеринга и настройки Scheduler, при этом по‑прежнему обеспечивает доступ к встроенному экземпляру Scheduler, когда нужен более тонкий контроль.

Ключевые особенности:

  • передавайте events, view и date как пропсы
  • настраивайте поведение через config и templates
  • обрабатывайте изменения пользователя через data.save или data.batchSave
  • используйте ref для прямого доступа к методам API Scheduler

Если вы новичок в DHTMLX Scheduler, смотрите документацию DHTMLX Scheduler документацию DHTMLX Scheduler для обзора возможностей.

Установка и доступ к npm​

Для оценки и установки профессионального пакета смотрите:

Требования к версии​

  • React 18+

Основное использование​

import { useMemo, useRef } from "react";
import ReactScheduler, {
type Event,
type ReactSchedulerRef,
type SchedulerConfig,
type SchedulerTemplates,
} from "@dhtmlx/trial-react-scheduler";
import "@dhtmlx/trial-react-scheduler/dist/react-scheduler.css";

const events: Event[] = [
{
id: 1,
text: "Product Strategy Hike",
classname: "blue",
start_date: new Date("2025-12-08T02:00:00Z"),
end_date: new Date("2025-12-08T10:20:00Z"),
},
];

export default function BasicSchedulerDemo() {
const schedulerRef = useRef<ReactSchedulerRef>(null);

const templates: SchedulerTemplates = useMemo(
() => ({
event_class: (_start, _end, event) => event.classname || "",
}),
[]
);

const config: SchedulerConfig = useMemo(
() => ({
first_hour: 6,
last_hour: 22,
hour_size_px: 60,
}),
[]
);

return (
<div style={{ height: "100vh" }}>
<ReactScheduler
ref={schedulerRef}
events={events}
view="week"
date={new Date("2025-12-08T00:00:00Z")}
templates={templates}
config={config}
/>
</div>
);
}

Привязка данных​

React Scheduler поддерживает две модели привязки данных.

React-состояние как источник истины (рекомендовано)​

В этой модели React (или менеджер состояний) владеет данными об событиях:

  • Scheduler читает события из пропсов
  • изменения пользователя вызывают ваш колбэк data.save
  • колбэк обновляет состояние React
  • React повторно рендерит Scheduler с обновлёнными пропсами
import { useMemo, useState } from "react";
import ReactScheduler, { type Event } from "@dhtmlx/trial-react-scheduler";

export default function ReactDrivenExample({ seedEvents }: { seedEvents: Event[] }) {
const [events, setEvents] = useState<Event[]>(seedEvents);

const data = useMemo(
() => ({
save: (entity: string, action: string, item: Event, id: string | number) => {
if (entity !== "event") return;

if (action === "create") {
setEvents((prev) => [...prev, item]);
return;
}

if (action === "update") {
setEvents((prev) => prev.map((e) => (e.id === id ? item : e)));
return;
}

if (action === "delete") {
setEvents((prev) => prev.filter((e) => e.id !== id));
}
},
}),
[]
);

return <ReactScheduler events={events} data={data} />;
}

Эта модель особенно удобна, когда другие элементы UI на React должны оставаться синхронизированными с данными Scheduler.

Scheduler как источник истины​

В этой модели Scheduler управляет своим внутренним состоянием и перенаправляет изменения в ваш бэкенд.

<ReactScheduler
data={{
load: "/api/scheduler/load",
save: "/api/scheduler/save",
}}
/>

Эта модель полезна, когда React не нужен для немедленного отражения каждого обновления.

Загрузка данных​

Данные можно загрузить, используя либо пропсы, либо data.load:

// Загрузка через пропсы
<ReactScheduler events={eventsFromState} />

// Загрузка через транспорт
<ReactScheduler data={{ load: "/api/scheduler/load" }} />

Для требований к формату данных смотрите Загрузка данных.

Сохранение изменений​

data.save может быть URL-адресом или колбэком.

<ReactScheduler
data={{
save: async (entity, action, item, id) => {
if (entity !== "event") return;

if (action === "create") {
const response = await fetch("/api/events", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});

const created = await response.json();
return { id: created.id };
}

if (action === "update") {
await fetch(`/api/events/${id}`, {
method: "PUT",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});
}

if (action === "delete") {
await fetch(`/api/events/${id}`, { method: "DELETE" });
}
},
}}
/>

Для деталей поведения на стороне бэкенда смотрите Server Integration.

Замена Lightbox​

Scheduler включает встроенный редактор событий под названием Lightbox.

Его можно заменить, используя customLightbox:

import React, { useState } from 'react';

export interface CustomLightboxProps {
data?: any;
onSave?: (event: any) => void;
onCancel?: () => void;
onDelete?: () => void;
}

const CustomLightbox: React.FC<CustomLightboxProps> = ({
data,
onSave,
onCancel,
onDelete
}) => {

let updatedEventText = data.text || "";

const handleSaveClick = () => {
if(onSave)
onSave({ ...data, text: updatedEventText });
};

function PaperComponent(props: any) {
const nodeRef = React.useRef(null);
return (
<Draggable
nodeRef={nodeRef"
handle="#draggable-dialog-title"
cancel={'[class*="MuiDialogContent-root"], input,textarea'}
>
<Paper {...props} ref={nodeRef}/>
</Draggable>
);
}


function TextComponent() {
const [description, setDescription] = useState<string>(data.text || '');

return (
<TextField
id="event_text"
hiddenLabel
multiline
value="{description}"
autoFocus
onChange="{(e)" => {
updatedEventText = e.target.value;
setDescription(e.target.value)
}}
sx="{{" width: '100%', padding: '8px', marginTop: '10px' }}
/>
)
}


return (
<Dialog
open={true}
PaperComponent={PaperComponent}
aria-labelledby="draggable-dialog-title"
className="lightbox"
onClose={onCancel}
>
<DialogTitle style={{ cursor: 'move' }} id="draggable-dialog-title">
Edit Event
</DialogTitle>
<DialogContent>
<DialogContentText id="alert-dialog-description">
Description
</DialogContentText>

<TextComponent />

<DialogActions className='buttons'>
<Button variant="contained" onClick={handleSaveClick}>Save</Button>
<Button variant="contained" onClick={onCancel}>Cancel</Button>
<Button variant="contained" onClick={onDelete}>Delete</Button>
</DialogActions>
</DialogContent>
</Dialog>

);
};

export default CustomLightbox;

Вы также можете перехватить открытие редактора с помощью onBeforeLightbox:

import { useEffect, useRef } from 'react';
import ReactScheduler from "@dhx/react-scheduler";
import "@dhx/react-scheduler/dist/react-scheduler.css";
import { useNavigate } from 'react-router-dom';


export default function BasicInitDemo() {
const schedulerRef = useRef<any>(null);

const { events, handleSaveEvent, handleDeleteEvent, createEvent }
= useOutletContext<SchedulerEditorContext>();
const navigate = useNavigate();

const handleEventEdit = (id: any) => {
const schedulerInstance = schedulerRef.current?.instance;
navigate(`/editor/${id}`, { state: { task: schedulerInstance.getTask(id) } });
};

return (
<ReactScheduler
ref={schedulerRef}
tasks={events}
onBeforeLightbox={handleEventEdit} />
);
}

Справка: onBeforeLightbox

Замена встроенных модальных окон​

Удаление можно переопределить через modals.

<ReactScheduler
modals={{
onBeforeEventDelete: ({ event, callback, schedulerInstance }) => {
if (window.confirm(`Delete "${event.text}"?`)) {
callback(); // вызов колбэка удалит событие
}
},
}}
/>

Настройка модального окна подтверждения повторяемости​

Когда пользователь редактирует или перетаскивает повторяющееся событие, появляется модальное окно подтверждения, которое спрашивает: изменить только это вхождение, это и последующие события или всю серию. Можно заменить встроенный диалог на свой через modals.onRecurrenceConfirm.

Колбек получает контекст и должен вернуть решение (или Promise, который резолвится в решение):

ПолеТипОписание
origin"lightbox" | "dnd"Было ли действие инициировано из Lightbox или перетаскиванием
occurrenceanyКонкретное вхождение, которое редактируется
seriesanyРодительская повторяющаяся задача
labelsobjectЛокализованные подписи: title, ok, cancel, occurrence, following, series
optionsstring[]Доступные варианты, например ["occurrence", "following", "series"]

Возвращаемое значение (RecurrenceDecision): "occurrence", "following", "series", или null для отмены.

Пример:

import { useState, useCallback } from "react";

function App() {
const [recurrencePrompt, setRecurrencePrompt] = useState(null);

const onRecurrenceConfirm = useCallback((context) => {
return new Promise((resolve) => {
setRecurrencePrompt({ context, resolve });
});
}, []);

return (
<>
<ReactScheduler
modals={{ onRecurrenceConfirm }}
/>
{recurrencePrompt && (
<MyRecurrenceDialog
options={recurrencePrompt.context.options}
labels={recurrencePrompt.context.labels}
onSelect={(choice) => {
recurrencePrompt.resolve(choice);
setRecurrencePrompt(null);
}}
onCancel={() => {
recurrencePrompt.resolve(null);
setRecurrencePrompt(null);
}}
/>
)}
</>
);
}

Фильтрация​

Используйте проп filter, чтобы управлять тем, какие события отображаются:

import { useCallback, useState } from "react";

function FilteredScheduler({ events }: { events: any[] }) {
const [query, setQuery] = useState("");

const filterFn = useCallback(
(event: any) => {
if (!query.trim()) return true;
return event.text?.toLowerCase().includes(query.trim().toLowerCase());
},
[query]
);

return (
<>
<input
placeholder="Search events..."
value={query}
onChange={(e) =/> setQuery(e.target.value)}
/>
<ReactScheduler events={events} filter={filterFn} />
</>
);
}

Доступ к базовому API Scheduler​

Когда пропсов недостаточно, получите доступ к экземпляру Scheduler через ref:

import { useEffect, useRef } from "react";
import ReactScheduler, { type ReactSchedulerRef } from "@dhx/react-scheduler";

export function DirectRefExample({ events }: { events: any[] }) {
const schedulerRef = useRef<ReactSchedulerRef>(null);

useEffect(() => {
const scheduler = schedulerRef.current?.instance;
if (!scheduler) return;

console.log("Events:", scheduler.getEvents());
scheduler.setCurrentView(new Date());
}, []);

return <ReactScheduler ref={schedulerRef} events={events} />;
}

Если вы мутируете Scheduler напрямую, держите пропсы React синхронизированными, чтобы избежать дрейфа состояния.

Смотрите Обзор методов Scheduler для доступных методов.

Избегайте конфликтов с пропсами React​

  • Если вы вручную вызываете scheduler.parse(( events )) или scheduler.addEvent() в вашем коде, учтите, что возможно потребуется синхронизировать пропсы React. Иначе при следующем рендере React может перезаписать ваши ручные изменения.
  • Рекомендуемый подход — полагаться на пропсы обёртки для событий или управлять ими в вашем состоянии React. Затем позвольте обёртке выполнить повторный разбор.

Совместимость с SSR-фреймворками (Next.js, Remix)​

примечание

React Scheduler поддерживает SSR. Во время серверного рендера он выводит контейнер-заглушку и выполняет гидратацию на клиенте.

Используйте руководства, специфичные для фреймворка, для деталей:

Дальнейшие шаги​

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.